unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SignalAnalysis, MeasuringPoint, ExtCtrls, TeeProcs, TeEngine, Chart,
  Series, StdCtrls, ComCtrls, Math;

type
  TForm1 = class(TForm)
    FFT: TFFTAnalysis;
    MPoint: TSpectrumPoint;
    FIR: TFIRAnalysis;
    Signal: TSignal;
    Panel2: TPanel;
    Panel3: TPanel;
    Chart1: TChart;
    Series1: TFastLineSeries;
    TrackBar6: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar1: TTrackBar;
    TrackBar7: TTrackBar;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure TrackBar7Change(Sender: TObject);
  private
    procedure ApplyFilters;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

var Equilizer: array [1..100] of single;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var i: integer;
begin
     for i := 1 to 7 do
     begin
          Equilizer[i] := 1;
     end;
     Button2Click(Sender);
end;

procedure TForm1.ApplyFilters;
var Step: single;
    i,k: integer;
    ASignal: TTimeSignal;
begin
     Step := MPoint.Spectrum.BandWidthH/7;
     FIR.AutoCalculate := False;
     FIR.CenterFrequency := Step/2;
     FIR.Bandwidth := 0;
     FIR.TransitionBW1 := Step;
     FIR.TransitionBW2 := 0;
     FIR.ApplyChanges;   {LowPass}
     ASignal := TTimeSignal.Create;
     ASignal.Length := FIR.FirTaps.Length;
     for k := 0 to FIR.FIRTaps.Length-1 do ASignal.Data[k] := (Equilizer[1])*FIR.FIRTaps.Data[k];
     for i:= 2 to 6 do
     begin
          FIR.CenterFrequency := FIR.CenterFrequency + Step;
          FIR.TransitionBW1 := Step;
          FIR.TransitionBW2 := Step; {Bandpass}
          Fir.ApplyChanges;
          for k := 0 to FIR.FIRTaps.Length-1 do
          begin
              ASignal.Data[k] := ASignal.Data[k] +
                (Equilizer[i])*(FIR.FirTaps.Data[k]);
          end;
     end;
     FIR.CenterFrequency := MPoint.Spectrum.BandWidthH-Step/2;
     FIR.TransitionBW1 := 0; {High pass}
     Fir.ApplyChanges;
     for k := 0 to FIR.FIRTaps.Length-1 do ASignal.Data[k] := ASignal.Data[k] + FIR.FIRTaps.Data[k]*(Equilizer[7]);
     for k := 0 to FIR.FIRTaps.Length-1 do FIR.FIRTaps.Data[k] := ASignal.Data[k];
     Fir.Init;
     Label1.Caption := 'Filter taps: ' + IntToStr(FIR.FilterLength);
     ASignal.Destroy;
end;


procedure TForm1.Button2Click(Sender: TObject);
var n, i: integer;
    SPC: TSpectrum;
begin
     ApplyFilters;
     n := (FIR.FilterLength div MPoint.Length)+2;
     for i:= 1 to n do
     begin
           Signal.ProcessData;
           FIR.ProcessData;
     end;
     FFT.AnalyzeData;
     Series1.Clear;
     Chart1.LeftAxis.Automatic := False;
     Spc := MPoint.Spectrum;
     for i:= 0 to Spc.Length-1 do
     begin
           Series1.AddXY(Spc.BandWidthL+(i)/Spc.Length*Spc.BandWidthH,
                   Spc.Amplt[i],'',clTeeColor);
     end;
     if FFT.Logarithmic then
     begin
         Chart1.LeftAxis.SetMinMax(-20, FFT.ResultData.MaxAmplt)
     end
     else
     begin
         Chart1.LeftAxis.SetMinMax(-0.1, FFT.ResultData.MaxAmplt)
     end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
     if CheckBox1.Checked then
     begin
          FFT.Logarithmic := True;
          Chart1.LeftAxis.Title.Caption := 'dB';
     end else
     begin
          FFT.Logarithmic := False;
          Chart1.LeftAxis.Title.Caption := 'V';
     end;
     Button2Click(Sender);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
     Equilizer[1] := Power(10, -TrackBar1.Position/20);
     Button2Click(Sender);
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
     Equilizer[2] := Power(10, -TrackBar2.Position/20);
     Button2Click(Sender);
end;

procedure TForm1.TrackBar3Change(Sender: TObject);
begin
     Equilizer[3] := Power(10, -TrackBar3.Position/20);
     Button2Click(Sender);
end;

procedure TForm1.TrackBar4Change(Sender: TObject);
begin
     Equilizer[4] := Power(10, -TrackBar4.Position/20);
     Button2Click(Sender);
end;

procedure TForm1.TrackBar5Change(Sender: TObject);
begin
     Equilizer[5] := Power(10, -TrackBar5.Position/20);
     Button2Click(Sender);
end;

procedure TForm1.TrackBar6Change(Sender: TObject);
begin
     Equilizer[6] := Power(10, -TrackBar6.Position/20);
     Button2Click(Sender);
end;

procedure TForm1.TrackBar7Change(Sender: TObject);
begin
     Equilizer[7] := Power(10, -TrackBar7.Position/20);
     Button2Click(Sender);
end;

end.
